
#ifndef __GST_PALMADPCM_H__
#define __GST_PALMADPCM_H__

#include <gst/gst.h>

#define PACKAGE "palm-media-gstreamer-plugins"
#define VERSION "1.0"

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define GST_TYPE_PALMADPCM \
  (gst_palmadpcm_get_type())
#define GST_PALMADPCM(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),GST_TYPE_PALMADPCM,GstpalmADPCM))
#define GST_PALMADPCM_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),GST_TYPE_PALMADPCM,GstpalmADPCMClass))
#define GST_IS_PLUGIN_TEMPLATE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_PALMADPCM))
#define GST_IS_PLUGIN_TEMPLATE_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_PALMADPCM))

typedef struct _GstpalmADPCM      GstpalmADPCM;
typedef struct _GstpalmADPCMClass GstpalmADPCMClass;

struct _GstpalmADPCM
{
  GstElement element;

  GstPad *sinkpad, *srcpad;

  gboolean silent;
  gboolean codec_initialized;
  gboolean bRunning;
  gint rate, channels;
  gint block_align;
  guint32 adpcm_type;

  unsigned char* pExtraData;

  PalmAudioADPCMParamType ADPCMParams;
  PalmAudioPCMParamType PCMParams;

  PalmCodecSession pSession;
};

struct _GstpalmADPCMClass 
{
  GstElementClass parent_class;
};

GType gst_palmadpcm_get_type (void);

G_END_DECLS

#endif /* __GST_PALMADPCM_H__ */
